// 04WebServerDlg.cpp : 実装ファイル
//

#include "stdafx.h"
#include "04WebServer.h"
#include "04WebServerDlg.h"
#include "systemservice.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ダイアログ データ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMy04WebServerDlg ダイアログ



CMy04WebServerDlg::CMy04WebServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy04WebServerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy04WebServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy04WebServerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_ADD, OnBnClickedAdd)
	ON_BN_CLICKED(IDC_DEL, OnBnClickedDel)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CMy04WebServerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CMy04WebServerDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CMy04WebServerDlg::OnBnClickedButton7)
END_MESSAGE_MAP()


// CMy04WebServerDlg メッセージ ハンドラ

BOOL CMy04WebServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	_CrtMemCheckpoint( &m_checkpoint );
	
	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CMy04WebServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CMy04WebServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CMy04WebServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMy04WebServerDlg::OnBnClickedOk()
{
	if(GET_APP()->StartServer())
		MessageBox(GET_APP()->GetServerErrorInfo());
}

void CMy04WebServerDlg::OnBnClickedCancel()
{
	GET_APP()->StopServer();
	OnCancel();
}

void CMy04WebServerDlg::OnBnClickedButton1()
{
	GET_APP()->StopServer();
}

void CMy04WebServerDlg::OnBnClickedButton2()
{
	GET_APP()->DumpContext();
}

void CMy04WebServerDlg::OnBnClickedAdd()
{
	GET_APP()->RegisterService(TRUE);
}

void CMy04WebServerDlg::OnBnClickedDel()
{
	GET_APP()->RegisterService(FALSE);
}

void CMy04WebServerDlg::OnBnClickedButton3()
{
//	GET_APP()->RegisterApp(TRUE);
}

void CMy04WebServerDlg::OnBnClickedButton4()
{
//	GET_APP()->RegisterApp(FALSE);
}

void CMy04WebServerDlg::OnBnClickedButton5()
{
#ifdef _DEBUG
	_CrtMemState s1;
	_CrtMemCheckpoint( &s1 );
	_CrtMemDumpStatistics( &s1 );
#endif
}

void CMy04WebServerDlg::OnBnClickedButton6()
{
#ifdef _DEBUG
	_CrtMemCheckpoint( &m_checkpoint );
#endif
}

void CMy04WebServerDlg::OnBnClickedButton7()
{
#ifdef _DEBUG
	_CrtMemState cur, diff;
	_CrtMemCheckpoint( &cur );
	if ( _CrtMemDifference( &diff, &m_checkpoint, &cur) )
	{
		TRACE(_T("Detect Leak\n"));
	   _CrtMemDumpStatistics( &diff );
	}
	else
	{
		TRACE(_T("Not Leak\n"));
	}
#endif
}
